uses crt;                               { wegen READKEY }

const Kombinationen = longint(1 shl 25)-1;{ Anzahl der Mglichkeiten, um die Lichter zu schalten }

var Minimum   : byte;                   { gefundenes Minimum an leuchtenden Lampen }
    KlickFeld : LongInt;                { enthlt die anzuklickenden Lampen }
    XORMaske  : array[1..25] of LongInt;{ XOR-Maske aller verschiedenen Felder }
    BitMaske  : array[1..25] of LongInt;{ zum Ausmaskieren einzelner Bits }


procedure BaueTabelle;                  { berechnet XORMaske und BitMaske }
var x,y,x2,y2     : byte;               { Laufvariablen }
    AktuelleMaske : byte;               { aktuell bearbeitete Position in der XORMaske }
    Feld          : array[0..6,0..6] of boolean;
                                        { Feld zur Erstellung der XORMaske }
begin
   fillchar(BitMaske,sizeof(BitMaske),0);{ erstmal die Bitmaske komplett lschen }
   for x:=1 to 25 do
      BitMaske[x]:=1 shl (Longint(x)-1); { das entsprechende Bit setzen (bei x=5 Bit 5) }

   fillchar(XORMaske,sizeof(XORMaske),0);{ erstmal die XORMaske komplett lschen }
   AktuelleMaske:=1;                    { bei Lampe 1 anfangen }
   for y:=1 to 5 do                     { alle Felder von oben nach unten }
      for x:=1 to 5 do                  { innere Schleife: Felder von links nach rechts }
      begin
         fillchar(Feld,sizeof(Feld),false);{ Feld lschen }
         Feld[x,y]:=true;               { das Licht selbst setzen }
         Feld[x-1,y]:=true;             { alle beeinfluten Lampen auch markieren }
         Feld[x+1,y]:=true;
         Feld[x,y-1]:=true;
         Feld[x,y+1]:=true;

         for y2:=5 downto 1 do          { alle Lampen abtasten: unten nach oben }
            for x2:=5 downto 1 do       { von rechts nach links }
            begin
               XORMaske[AktuelleMaske]:=XORMaske[AktuelleMaske] shl 1;
                                        { um 1 Bit nach links schieben }
               if Feld[x2,y2] then      { dieses Feld beeinflut ? }
                  inc(XORMaske[AktuelleMaske]);{ ja, Bit 1 in Maske setzen }
            end;

         inc(AktuelleMaske);            { nchste Lampe }
      end;
end;


procedure Suche(StartFeld: LongInt);    { durchsucht das gegebene Feld }
var Zahl      : LongInt;                { durchluft alle Kombinationen }
    Lauf      : byte;                   { Laufvariable }
    NeuFeld   : LongInt;                { das daraus entstehende Feld }
    An        : byte;                   { Anzahl der leuchtenden Lampen }
begin
   for Zahl:=0 to Kombinationen do      { alle Kombinationen durchlaufen }
   begin
      NeuFeld:=StartFeld;               { die Ausgangsbeleuchtung laden }

      for Lauf:=1 to 25 do              { alle Bits der Kombination durchlaufen }
         if (Zahl and BitMaske[Lauf])>0 then{ ist Bit gesetzt ? }
            NeuFeld:=NeuFeld xor XORMaske[Lauf];
                                        { ja, Mausklick simulieren }
      An:=0;                            { vermuten, da keine Lampe mehr leuchtet }
      for Lauf:=1 to 25 do              { alle Lampen durchlaufen }
         if (NeuFeld and BitMaske[Lauf])>0 then{ leuchtet die Lampe ? }
            inc(An);                    { ja, Anzahl der Lampen um 1 erhhen }

      if An<Minimum then                { neues Minimum gefunden ? }
      begin                             { ja }
         Minimum:=An;                   { Minimalzahl an Lampen sichern }
         KlickFeld:=Zahl;               { die Klickfolge sichern }
         if Minimum=0 then              { brennt keine Lampe mehr ? }
            break;                      { ja, abbrechen }
      end;
   end;
end;


var StartFeld : LongInt;                { enthlt das Ausgangsfeld }
    Zeichen   : char;                   { eingelesenes Zeichen }
    x,y       : byte;                   { Laufvariablen }
    Position  : byte;                   { Bitposition im Feld }
begin
   BaueTabelle;                         { Tabellen initialisieren }

   writeln('0=aus, 1=ein    BEI FEHLEINGABE CTRL-C !');
                                        { Eingabehinweis ausgeben }
   for y:=1 to 5 do                     { von oben nach unten einlesen }
   begin
      for x:=1 to 5 do                  { von links nach rechts einlesen }
      begin
         StartFeld:=StartFeld shl 1;    { um 1 Bit nach links schieben }

         Zeichen:=readkey;              { Zeichen einlesen }
         write(Zeichen,' ');            { und ausgeben (zur Kontrolle) }
         if Zeichen='1' then            { falls 1, dann brennt Lampe }
            inc(StartFeld);
      end;
      writeln;                          { nchste Zeile }
   end;
   writeln;                             { Leerzeile zur optischen Abgrenzung }

   Minimum:=26;                         { unmglicher Minimalfall, da hchstens 25 Lampen immer brennen }
   Suche(StartFeld);                    { Suche beginnen }

   writeln('Die Anzahl der leuchtenden Lampen konnte auf ',Minimum,' reduziert werden.');
                                        { Meldung der neuen Mindestzahl an Lampen ausgeben }
   writeln('Folgende Felder sind anzuklicken: ');
                                        { Klickfolge ausgeben }
   Position:=1;                         { bei Position 1 anfangen (oben links) }
   for y:=1 to 5 do                     { von oben nach unten }
      for x:=1 to 5 do                  { von links nach rechts }
      begin
         if (KlickFeld and BitMaske[Position])>0 then{ mu hier geklickt werden ? }
            write('(',x,'/',y,'),  ');  { ja, Position ausgeben }
         inc(Position);                 { nchste Lampe }
      end;
end.